/*
 * HexHAL_Grid - Tim Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.image.ImageObserver;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Random;
   import java.util.Date;
   import java.io.*;
   import java.lang.Object;

/* To do:
 * ======
 *
 * Add a "low number of bits"
 * live/dead array - to postpone cache thrashing...?
 *
 */

   public class HexHAL_Grid extends Object {
      final static int QBERT      = 0;
      final static int MARGOLUS   = 1;
      final static int SOD        = 2;
      final static int WOLF       = 3;
      final static int TRIUMPHANT = 4;
   
      static int max_non_linearity;
   
      static int local_history_index;
      static int[][] in_grid;
      static int[][] out_grid;
      static int[][] tmp_grid;
      static int[][] help_grid;
   
      static int[][] grid_colour;
   
      static int[][] LUT_Table;
   
      static int[] bin256;
      static int[] sort256;
   
   
      // static HexHAL_LUT[] LUT;
   
      static int poly8_x[] = new int[8];
      static int poly8_y[] = new int[8];
   
      static int poly6_x[] = new int[6];
      static int poly6_y[] = new int[6];
   
      static int poly4_x[] = new int[4];
      static int poly4_y[] = new int[4];
   
      static int poly3_x[] = new int[3];
      static int poly3_y[] = new int[3];
   
      final static int number_HexHAL_LUT   = 16; // a power of two, please...
      final static int number_HexHAL_LUTmo = number_HexHAL_LUT - 1;
   
      static int maxstates;
      static int maxstatesmo;
      static int maxstatesmt;
   
      static int mask_value;
      static int BPC_value;
   
      static HexHAL_Canvas random_canvas;
   
      static int mutation_rate = 0;
      static int radiation_rate = 4;
   
      static int any_selection = 0;
   
      static int rnd_frame;
      static int coverage_counter;
   
      static int invert_edges = 1;
   
      static int mouse_pressed = 0;
   
      static int a_atgrid = 0;
   
      static int sparse = 1;
   
      static int reverse = 0;
      static int direction = 1;
   
      static int newborn;
      static int generation;
   
      // static int frame;
   
      static int from_cell;
      static int from_cell1;
   
      static int current_direction;
   
      //int edge_death;
   
      static boolean RepaintAll = true;
   
      static Graphics graphics_handle;
   
      // static int ss_output;
      static int ss_north;
      static int ss_west;
      static int ss_centre;
      static int ss_east;
      static int ss_south;
      static int ss_input;
   
      static int next_result;
      static int last_result;
   
      static int next_ss;
      static int last_ss;
   
      static int cell_se;
      static int cell_ne;
      static int cell_w;
      static int cell_c;
      static int cell_future;
   
      static int from_dir;
   
      static int last_temp;
      static int temp_x;
      static int temp_y;
   
      static int temp;
      static int temp2;
      static int temp3;
      static int temp4;
   
      static int tempA;
      static int temp2A;
      static int temp3A;
      static int temp4A;
   
      final static int snake_bg_colour = 0x00;
      final static int snake_eye_colour = 0x17F; // eyes
      final static int wall_colour = 0x1DA;
   
      static int oldcolour;
      static int last_colour;
   
      static int colour;
      static int default_colour;
      static int forward_colour;
      static int backward_colour;
   
      static int colourA;
      static int default_colourA;
      static int forward_colourA;
      static int backward_colourA;
   
      static int lastx = -1 ,lasty = -1;
   
      static int side = 100;
      static int inttemp;
   
      static Random rnd = new Random();
   
      static int[] snake_LUT1;
      static int[] snake_LUT2;
      static int[] snake_LUT3;
      static int[] snake_LUT4;
      static int[] snake_LUT5;
      static int[] snake_LUT6;
   
      static int smear_x = 0;
      static int smear_y = 0;
   
      static int hside;
      static int vside;
   
      static int gridsize = 4;
      static int cellsize;
   
      static int hexgridsize;
      static int hexcellsize;
   
      static int halfcellsize;
      static int halfgridsize;
   
      static int quartgridsize;
      static int quartcellsize;
   
      static int sharedgridsize;
      static int sharedcellsize;
   
      static int sharedhalfgridsize;
      static int sharedhalfcellsize;
   
      static int sharedquartgridsize;
      static int sharedquartcellsize;
   
      static int geometry = TRIUMPHANT;
   
      static int x_plot_gridsize;
      static int y_plot_gridsize;
   
      static int x_plot_cellsize;
      static int y_plot_cellsize;
   
      static int shared_y_plot_gridsize;
      static int shared_y_plot_cellsize;
   
      static int hsidemo;
      static int vsidemo;
   
      static int cx;
      static int cy;
   
      static int ncx;
      static int ncy;
   
      static int n0, s0, e0, w0;
      static int c0, c1;
      static int new_a0;
      static int new_a1;
      static int new_status;
      static int new_value;
      static int new_direction = 0;
   
      static int cell_number = 0;
   
      static int width;
      static int height;
   
      static int to_direction[];
      static int from_direction[];
      static int develop[];
      static int repro_direction[];
   
      static int appletsize = 512;
   
      // static int mask_value = 15;
   
      final static int MSGQ_SIZE = 32;
      final static int MONQ_SIZE = 512; // expands...
      final static int EDGELIST_SIZE = 1024; // !
   
      // OK, get that chunder-bucket ready ;-)
   
   
      final static int mask_act  = 0x0F;
      final static int mask_dev  = 0x70;
      final static int mask_devx = 0xF0;
      final static int DEAD      = 0x00;
      final static int WALL      = 0x7F;
   
      final static int CELL_SE_E_C    = 0x01;
      final static int CELL_W_SW_C    = 0x02;
      final static int CELL_NE_NW_C   = 0x03;
      final static int CELL_SE_E      = 0x04;
      final static int CELL_W_SW      = 0x05;
      final static int CELL_NE_NW     = 0x06;
      final static int CELL_SE_SW     = 0x07;
      final static int CELL_W_NW      = 0x08;
      final static int CELL_NE_E      = 0x09;
      final static int CELL_SE_NW     = 0x0A;
      final static int CELL_W_E       = 0x0B;
      final static int CELL_NE_SW     = 0x0C;
   
      final static int DEV_SE_C       = 0x10;
      final static int DEV_W_C        = 0x20;
      final static int DEV_NE_C       = 0x30;
      final static int DEV_SE         = 0x40;
      final static int DEV_W          = 0x50;
      final static int DEV_NE         = 0x60;
      final static int DEV_HEAD       = 0x70;
   
      final static int NORTH_WEST = 1;
      final static int NORTH_EAST = 2;
      final static int SOUTH_WEST = 4;
      final static int SOUTH_EAST = 8;
      final static int EAST       = 16;
      final static int WEST       = 32;
   
   
      // start types
   
   
   // colours...
      final static int COLOUR_MAX     = 512;
   
      final static int CONTROL_WIDTH  = 192;
      final static int CONTROL_HEIGHT = 32;
   
   // display type...
      final static int HEADSANDCELLS    = 0;
      final static int CELLTYPES        = 1;
      final static int DEVELOPMENT      = 2;
      final static int SNAKELIKE        = 3;
   
      // size selection?
      final static int _SIZE_UNK      = 0;
      final static int _SIZE_LARGE    = 1;
      final static int _SIZE_SMALL    = 2;
   
      final static int _TWIST_UNK     = 0;
      final static int _TWIST_HIGH    = 1;
      final static int _TWIST_LOW     = 2;
   
      final static int _EXTENT_UNK      = 0;
      final static int _EXTENT_LARGE    = 1;
      final static int _EXTENT_THIN     = 2;
      final static int _EXTENT_LONG     = 3;
      final static int _EXTENT_LONGTHIN = 4;
   
      final static int _PATTERN_UNK = 0;
      final static int _PATTERN_ON  = 1;
      final static int _PATTERN_OFF = 2;
      final static int _PATTERN_HAL = 3;
   
      final static int _MUT_OFF    =  -1;
      final static int _MUT_VLOW   =   1;
      final static int _MUT_LOW    =   2;
      final static int _MUT_QLOW   =   3;
      final static int _MUT_MEDIUM =   4;
      final static int _MUT_QHIGH  =   6;
      final static int _MUT_HIGH   =   8;
      final static int _MUT_VHIGH  =  10;
   
   
      final static int _FRAME_1   = 0;
      final static int _FRAME_2   = 1;
      final static int _FRAME_4   = 3;
      final static int _FRAME_8   = 7;
      final static int _FRAME_16  = 15;
      final static int _FRAME_32  = 31;
   
      // colours
      static Color WorldColour    = Color.black;
      static Color GridColour     = Color.black;
      // static Color CellColour     = Color.white;
      static Color PageColour     = new Color(0xF0,0xE8,0xFF);
   
      // static Color COLOUR_RIPE    = Color.red;
   
   
      static Color[] colours;
   
      static int display_type    = SNAKELIKE;
   
      // static int size_sel        = _SIZE_UNK;
      // static int twist_sel       = _TWIST_UNK;
      // static int extent_sel      = _EXTENT_UNK;
      // static int pattern_sel     = _PATTERN_UNK;
      // static int start_type      = 0;
   
      // static int initial_activity_type = INACTIVE; // RIPE! ;-)
   
      static int LUT_NUMBER = 16;
   
      public static void initialise(int resolutionx, int resolutiony) {
         int i,j;
      
        // LUT_Table = new int[16][LUT_NUMBER];
      
         mutation_rate = _MUT_OFF;
      
         set_size(resolutionx,resolutiony);
      
         colours = new Color[COLOUR_MAX];
      
         colours[0] = new Color(64,64,64);
      
      	// colours[1] = new Color(255,255,255);
      
         for (int c = 1; c < COLOUR_MAX; c++) {
            colours[c] = new Color((c & 7) * 32,(c & 56) * 4,(c & 448) / 2);
         }
      
         bin256 = new int[256];
         sort256 = new int[256];
      
         // should be a proper LUT :-(
      
         from_direction = new int[16];
         from_direction[1] = SOUTH_EAST;
         from_direction[2] = WEST;
         from_direction[3] = NORTH_EAST;
         from_direction[4] = SOUTH_EAST;
         from_direction[5] = WEST;
         from_direction[6] = NORTH_EAST;
         from_direction[7] = SOUTH_EAST;
         from_direction[8] = WEST;
         from_direction[9] = NORTH_EAST;
         from_direction[10] = SOUTH_EAST;
         from_direction[11] = WEST;
         from_direction[12] = NORTH_EAST;
      
         to_direction = new int[16];
         to_direction[1]  = EAST;
         to_direction[2]  = SOUTH_WEST;
         to_direction[3]  = NORTH_WEST;
         to_direction[4]  = EAST;
         to_direction[5]  = SOUTH_WEST;
         to_direction[6]  = NORTH_WEST;
         to_direction[7]  = SOUTH_WEST;
         to_direction[8]  = NORTH_WEST;
         to_direction[9]  = EAST;
         to_direction[10] = NORTH_WEST;
         to_direction[11] = EAST;
         to_direction[12] = SOUTH_WEST;
      
         repro_direction = new int[16];
         repro_direction[1]  = NORTH_WEST;
         repro_direction[2]  = EAST;
         repro_direction[3]  = SOUTH_WEST;
         repro_direction[4]  = 0;
         repro_direction[5]  = 0;
         repro_direction[6]  = 0;
         repro_direction[7]  = 0;
         repro_direction[8]  = 0;
         repro_direction[9]  = 0;
         repro_direction[10] = 0;
         repro_direction[11] = 0;
         repro_direction[12] = 0;
      
         develop = new int[16];
         develop[1] = DEV_SE_C;
         develop[2] = DEV_W_C;
         develop[3] = DEV_NE_C;
         develop[4] = DEV_SE;
         develop[5] = DEV_W;
         develop[6] = DEV_NE;
         develop[7] = DEV_SE;
         develop[8] = DEV_W;
         develop[9] = DEV_NE;
         develop[10] = DEV_SE;
         develop[11] = DEV_W;
         develop[12] = DEV_NE;
      
         snake_LUT1 = new int[30];
         snake_LUT2 = new int[30];
         snake_LUT3 = new int[30];
         snake_LUT4 = new int[30];
         snake_LUT5 = new int[30];
         snake_LUT6 = new int[30];
      
         snake_LUT1[0] = 0;
         snake_LUT2[0] = 0;
         snake_LUT3[0] = 0;
         snake_LUT4[0] = 0;
         snake_LUT5[0] = 0;
         snake_LUT6[0] = 0;
      
         snake_LUT1[1] = 1;
         snake_LUT2[1] = 2;
         snake_LUT3[1] = 1;
         snake_LUT4[1] = 4;
         snake_LUT5[1] = 3;
         snake_LUT6[1] = 5;
      
         snake_LUT1[2] = 3;
         snake_LUT2[2] = 1;
         snake_LUT3[2] = 5;
         snake_LUT4[2] = 1;
         snake_LUT5[2] = 4;
         snake_LUT6[2] = 2;
      
         snake_LUT1[3] = 4;
         snake_LUT2[3] = 5;
         snake_LUT3[3] = 2;
         snake_LUT4[3] = 3;
         snake_LUT5[3] = 1;
         snake_LUT6[3] = 1;
      
         snake_LUT1[4] = 1;
         snake_LUT2[4] = 2;
         snake_LUT3[4] = 1;
         snake_LUT4[4] = 4;
         snake_LUT5[4] = 3;
         snake_LUT6[4] = 5;
      
         snake_LUT1[5] = 3;
         snake_LUT2[5] = 1;
         snake_LUT3[5] = 5;
         snake_LUT4[5] = 1;
         snake_LUT5[5] = 4;
         snake_LUT6[5] = 2;
      
         snake_LUT1[6] = 4;
         snake_LUT2[6] = 5;
         snake_LUT3[6] = 2;
         snake_LUT4[6] = 3;
         snake_LUT5[6] = 1;
         snake_LUT6[6] = 1;
      
         snake_LUT1[7] = 1;
         snake_LUT2[7] = 1;
         snake_LUT3[7] = 2;
         snake_LUT4[7] = 3;
         snake_LUT5[7] = 4;
         snake_LUT6[7] = 5;
      
         snake_LUT1[8] = 4;
         snake_LUT2[8] = 2;
         snake_LUT3[8] = 5;
         snake_LUT4[8] = 1;
         snake_LUT5[8] = 3;
         snake_LUT6[8] = 1;
      
         snake_LUT1[9] = 3;
         snake_LUT2[9] = 5;
         snake_LUT3[9] = 1;
         snake_LUT4[9] = 4;
         snake_LUT5[9] = 1;
         snake_LUT6[9] = 2;
      
         snake_LUT1[10] = 4;
         snake_LUT2[10] = 2;
         snake_LUT3[10] = 2;
         snake_LUT4[10] = 3;
         snake_LUT5[10] = 3;
         snake_LUT6[10] = 5;
      
         snake_LUT1[11] = 3;
         snake_LUT2[11] = 2;
         snake_LUT3[11] = 5;
         snake_LUT4[11] = 4;
         snake_LUT5[11] = 3;
         snake_LUT6[11] = 2;
      
         snake_LUT1[12] = 2;
         snake_LUT2[12] = 4;
         snake_LUT3[12] = 3;
         snake_LUT4[12] = 2;
         snake_LUT5[12] = 5;
         snake_LUT6[12] = 3;
      
         snake_LUT1[13] = 4;
         snake_LUT2[13] = 6;
         snake_LUT3[13] = 6;
         snake_LUT4[13] = 3;
         snake_LUT5[13] = 3;
         snake_LUT6[13] = 5;
      
         snake_LUT1[14] = 3;
         snake_LUT2[14] = 6;
         snake_LUT3[14] = 5;
         snake_LUT4[14] = 4;
         snake_LUT5[14] = 3;
         snake_LUT6[14] = 6;
      
         snake_LUT1[15] = 3;
         snake_LUT2[15] = 5;
         snake_LUT3[15] = 6;
         snake_LUT4[15] = 3;
         snake_LUT5[15] = 4;
         snake_LUT6[15] = 6;
      
         snake_LUT1[16] = 4;
         snake_LUT2[16] = 6;
         snake_LUT3[16] = 6;
         snake_LUT4[16] = 3;
         snake_LUT5[16] = 3;
         snake_LUT6[16] = 5;
      
         snake_LUT1[17] = 3;
         snake_LUT2[17] = 6;
         snake_LUT3[17] = 5;
         snake_LUT4[17] = 4;
         snake_LUT5[17] = 3;
         snake_LUT6[17] = 6;
      
         snake_LUT1[18] = 3;
         snake_LUT2[18] = 5;
         snake_LUT3[18] = 6;
         snake_LUT4[18] = 3;
         snake_LUT5[18] = 4;
         snake_LUT6[18] = 6;
      
         snake_LUT1[19] = 6;
         snake_LUT2[19] = 6;
         snake_LUT3[19] = 6;
         snake_LUT4[19] = 6;
         snake_LUT5[19] = 6;
         snake_LUT6[19] = 3;
      
         snake_LUT1[20] = 6;
         snake_LUT2[20] = 6;
         snake_LUT3[20] = 5;
         snake_LUT4[20] = 6;
         snake_LUT5[20] = 6;
         snake_LUT6[20] = 6;
      
         snake_LUT1[21] = 6;
         snake_LUT2[21] = 3;
         snake_LUT3[21] = 6;
         snake_LUT4[21] = 6;
         snake_LUT5[21] = 6;
         snake_LUT6[21] = 6;
      
         snake_LUT1[22] = 3;
         snake_LUT2[22] = 3;
         snake_LUT3[22] = 3;
         snake_LUT4[22] = 3;
         snake_LUT5[22] = 3;
         snake_LUT6[22] = 4;
      
         snake_LUT1[23] = 3;
         snake_LUT2[23] = 3;
         snake_LUT3[23] = 4;
         snake_LUT4[23] = 3;
         snake_LUT5[23] = 3;
         snake_LUT6[23] = 3;
      
         snake_LUT1[24] = 3;
         snake_LUT2[24] = 3;
         snake_LUT3[24] = 3;
         snake_LUT4[24] = 3;
         snake_LUT5[24] = 3;
         snake_LUT6[24] = 3;
      
         snake_LUT1[25] = 7;
         snake_LUT2[25] = 7;
         snake_LUT3[25] = 7;
         snake_LUT4[25] = 7;
         snake_LUT5[25] = 7;
         snake_LUT6[25] = 7;
      
      /*    case 0: colour = 0;                  // background
            case 1: colour = snake_bg_colour;   // snake background
            case 2: colour = forward_colour;   // general front
            case 3: colour = backward_colour; // general back
            case 4: colour = temp2;          // forwards eye
            case 5: colour = temp3;         // tail
            case 6: colour = SNAKE EYE;    // eye
            case 7: colour = WALL;    // wall
      */
      }
   
   
      public static void setupnewcells() {
         int x,y;
      
         for (x = 0; x < hside; x++) {
            for (y = 0; y < vside; y++) {
               in_grid[x][y] = 0;
               out_grid[x][y] = 0;
            }
         }
      }
   
   
      public static void set_size(int h, int v) {
         hside = h;
         vside = v;
      
         hsidemo = h - 1;
         vsidemo = v - 1;
      
         setGridSize(appletsize / h);
      
         // null old refs? no.
         in_grid = new int[h][v];
         out_grid = new int[h][v];
         help_grid = new int[h + 1][v + 1];
      
         grid_colour = new int[h][v];
      
         // tell browser!?? - or don't tell anyone...?
      
         setupnewcells();
      
         resetGrid();
      }
   
   
      public static void setPlotGridSize(int h, int v, int n) {
         x_plot_gridsize = h / n;
         y_plot_gridsize = v / n;
      
         x_plot_cellsize = x_plot_gridsize - 1;
         y_plot_cellsize = y_plot_gridsize - 1;
      
         if (x_plot_cellsize < 3) 
            x_plot_cellsize++;
      
         if (y_plot_cellsize < 3) 
            y_plot_cellsize++;
      
         if (isHexagonal() != 0) {
            shared_y_plot_gridsize = (y_plot_gridsize * 3) >>> 2;
            shared_y_plot_cellsize = ((y_plot_gridsize * 3) >>> 2) - 1;
         }
         else
         {
            shared_y_plot_gridsize = y_plot_gridsize;
            shared_y_plot_cellsize = y_plot_cellsize;
         }
      }
   
   
      public static void setGridSize(int s) {
         gridsize = s;
         halfgridsize = gridsize >> 1;
         quartgridsize = gridsize >> 2;
         hexgridsize = halfgridsize + quartgridsize;
      
         cellsize = gridsize - 1;
         halfcellsize = halfgridsize - 1;
         quartcellsize = quartgridsize - 1;
         hexcellsize = hexgridsize - 1;
      
         if (isHexagonal() != 0) {
            sharedgridsize = hexgridsize;
            sharedcellsize = hexcellsize;
         
            sharedhalfgridsize = hexgridsize >>> 1;
            sharedhalfcellsize = (hexgridsize >>> 1) - 1;
         
            sharedquartgridsize = hexgridsize >>> 2;
            sharedquartcellsize = (hexgridsize >>> 2) - 1;
         }
         else
         {
            sharedgridsize = gridsize;
            sharedcellsize = cellsize;
         
            sharedhalfgridsize = halfgridsize;
            sharedhalfcellsize = halfcellsize;
         
            sharedquartgridsize = quartgridsize;
            sharedquartcellsize = quartcellsize;
         }
      
         if (gridsize < 3)
            cellsize = gridsize;
      
         if (halfgridsize < 3)
            halfcellsize++;
      
         if (sharedgridsize < 3)
            sharedcellsize = sharedgridsize;
      
         if (sharedhalfgridsize < 3)
            sharedhalfcellsize++;
      
         if (halfgridsize < 1)
            halfgridsize = 1;
      
         if (gridsize < 1)
            gridsize = 1;
      
         width = hside * gridsize;
         height = vside * gridsize;
      }
   
   
      public static void resetGrid() {
         blankGrid();
      
         RepaintAll = true;
      }
   
   
      public static void setGrid() {
         for (cx = hside; cx-- > 0; ) {
            for (cy = vside; cy-- > 0; ) {
               in_grid[cx][cy] |= 0xFF;
            }
         }
      
         RepaintAll = true;
      }
   
   
     // don't call this...
      public static void blankGrid() {
         for (cx = hside; cx-- > 0; ) {
            for (cy = vside; cy-- > 0; ) {
               in_grid[cx][cy] &= 0xffffff00; // freeze, rnd, HexHAL_ blanked out...
            }
         }
      }
   
   
      final static public void calculate_grid() {
         if ((hside == 1) || (vside == 1)) {
            trivialCopy();
         }
         else
         {
            cx = 0;
            for (cy = vside; cy-- > 0; ) {
               process_one_edge_cell(); // ??
            }
         
            cx = hsidemo;
            for (cy = vside; cy-- > 0; ) {
               process_one_edge_cell();
            }
         
            cy = 0;
            for (cx = hsidemo; cx-- > 1; ) {
               process_one_edge_cell(); // ??
            }
         
            cy = vsidemo;
            for (cx = hsidemo; cx-- > 1; ) {
               process_one_edge_cell(); // ??
            }
         
            for (cy = vsidemo; cy-- > 1; ) {
               for (cx = hsidemo; cx-- > 1; ) {
                  cell_w  = in_grid[cx - 1][cy    ];
                  cell_ne = in_grid[cx + (cy & 1)][cy - 1]; // problem...
                  cell_se = in_grid[cx + (cy & 1)][cy + 1];
               
                  if ((cell_w | cell_ne | cell_se) == DEAD) {
                     if (out_grid[cx    ][cy    ] != DEAD) {
                        out_grid[cx    ][cy    ] = DEAD;
                     }
                  } 
                  else
                  {
                     cell_c  = in_grid[cx    ][cy    ];
                  
                     cell_process();
                  }
               }
            }
         }
      
         do_any_mutation();
         do_any_radiation();
      }
   
   
      // this code can be improved...
      final static void process_one_edge_cell() {
         cell_w  = safeRead(cx - 1,       cy    );
         cell_ne = safeRead(cx + (cy & 1),cy - 1); // problem...
         cell_se = safeRead(cx + (cy & 1),cy + 1);
      
         if ((cell_w | cell_ne | cell_se) == DEAD) {
            if (out_grid[cx    ][cy    ] != DEAD) {
               out_grid[cx    ][cy    ] = DEAD;
            }
         } 
         else
         {
            cell_c  = in_grid[cx    ][cy    ];
         
            cell_process();
         }
      }
   
   
      final static void cell_process() {
         if (cell_c == WALL) {
            cell_future = WALL;
         }
         else
         {
            cell_future = cell_c & mask_act;
            if (cell_future != DEAD ){
               from_dir = from_direction[cell_future];
               switch (from_dir) {
                  case NORTH_EAST:
                     if (cell_ne != WALL) {
                        temp = cell_ne & mask_devx;
                        if (temp != 0) { // development rotation
                           cell_future |= temp;
                        }
                        else
                        { // death
                           cell_future = DEAD;
                        }
                     }
                     else
                     {
                        cell_future = DEAD;
                     }
                  
                     break;
               
                  case SOUTH_EAST:
                     if (cell_se != WALL) {
                        temp = cell_se & mask_devx;
                        if (temp != 0) { // development rotation
                           cell_future |= temp;
                        }
                        else
                        { // death
                           cell_future = DEAD;
                        }
                     }
                     else
                     {
                        cell_future = DEAD;
                     }
                  
                     break;
               
                  case WEST:
                     if (cell_w != WALL) {
                        temp = cell_w & mask_devx;
                        if (temp != 0) { // development rotation
                           cell_future |= temp;
                        }
                        else
                        { // death
                           cell_future = DEAD;
                        }
                     }
                     else
                     {
                        cell_future = DEAD;
                     }
                  
                     break;
               }
            
            // change heads into ordinary cells...
               if ((cell_c & mask_dev) == DEV_HEAD) {
                  temp = cell_future & mask_act;
                  temp2 = cell_future & mask_dev;
               
                  if (temp == CELL_SE_E) {
                     switch (temp2) {
                        case DEV_NE_C:
                        case DEV_NE:
                           cell_future = temp2 | CELL_SE_SW;
                        
                           break;
                     
                        case DEV_SE_C:
                        case DEV_SE:
                           cell_future = temp2 | CELL_SE_NW;
                        
                           break;
                     
                     // case DEV_W_C:
                     // case DEV_W:
                        // cell_future = temp2 | CELL_W_E;
                        //break;
                     }
                  }
               
                  if (temp == CELL_W_SW) {
                     switch (temp2) {
                     //case DEV_NE_C:
                     //case DEV_NE:
                        //cell_future = temp2 | CELL_W_SW;
                        //break;
                     
                        case DEV_SE_C:
                        case DEV_SE:
                           cell_future = temp2 | CELL_W_NW;
                        
                           break;
                     
                        case DEV_W_C:
                        case DEV_W:
                           cell_future = temp2 | CELL_W_E;
                        
                           break;
                     }
                  }
               
                  if (temp == CELL_NE_NW) {
                     switch (temp2) {
                        case DEV_NE_C:
                        case DEV_NE:
                           cell_future = temp2 | CELL_NE_SW;
                        
                           break;
                     
                     // case DEV_SE_C:
                     // case DEV_SE:
                        // cell_future = temp2 | CELL_SE_NW;
                        // break;
                     
                        case DEV_W_C:
                        case DEV_W:
                           cell_future = temp2 | CELL_NE_E;
                        
                           break;
                     }
                  }
               }
            }
         
         // growth...
            if ((to_direction[cell_se & mask_act] & NORTH_WEST) != 0) {
               if (from_direction[cell_c & mask_act] != SOUTH_EAST) {
                  if ((cell_se & mask_dev) != DEV_HEAD) {
                     if ((cell_c == DEAD) || ((cell_c & mask_act) == CELL_NE_E)) {
                        if ((cell_c != DEAD)) { //  && ((cell_se & mask_dev) == DEV_SE_C)) {
                           cell_future = ((cell_se & mask_dev) >>> 4) | (cell_future & mask_dev);
                        // System.out.println("SE");
                        }
                        else
                        {
                           cell_future = ((cell_se & mask_dev) >>> 4) | DEV_HEAD;
                        }
                     }
                  }
               }
            }
         
            if ((to_direction[cell_ne & mask_act] & SOUTH_WEST) != 0) {
               if (from_direction[cell_c & mask_act] != NORTH_EAST) {
                  if ((cell_ne & mask_dev) != DEV_HEAD) {
                     if ((cell_c == DEAD) || ((cell_c & mask_act) == CELL_W_NW)) {
                        if ((cell_c != DEAD)) {
                           cell_future = ((cell_ne & mask_dev) >>> 4) | (cell_future & mask_dev);
                        }
                        else
                        {
                           cell_future = ((cell_ne & mask_dev) >>> 4) | DEV_HEAD;
                        }
                     }
                  }
               }
            }
         
            if ((to_direction[cell_w & mask_act] & EAST) != 0) {
               if (from_direction[cell_c & mask_act] != WEST) {
                  if ((cell_w & mask_dev) != DEV_HEAD) {
                     if ((cell_c == DEAD) || ((cell_c & mask_act) == CELL_SE_SW)) {
                        if ((cell_c != DEAD)) {
                           cell_future = ((cell_w & mask_dev) >>> 4) | (cell_future & mask_dev);
                        } 
                        else {
                           cell_future = ((cell_w & mask_dev) >>> 4) | DEV_HEAD;
                        }	
                     }
                  }
               }
            }
         
         // new reproduction...
            if (cell_se == (CELL_SE_E_C | DEV_W_C)) {
               if (from_direction[cell_c & mask_act] != SOUTH_EAST) {
                  if (cell_c == DEAD) {
                     cell_future = CELL_SE_SW | DEV_HEAD; // CELL_SE_SW | DEV_HEAD;
                  }
               }
            }
         
            if (cell_ne == (CELL_NE_NW_C | DEV_SE_C)) {
               if (from_direction[cell_c & mask_act] != NORTH_EAST) {
                  if (cell_c == DEAD) {
                     cell_future = CELL_NE_E | DEV_HEAD;
                  }
               }
            }
         
            if (cell_w == (CELL_W_SW_C | DEV_NE_C)) {
               if (from_direction[cell_c & mask_act] != WEST) {
                  if (cell_c == DEAD) {
                     cell_future = CELL_W_NW | DEV_HEAD;
                  }
               }
            }
         }
      
      	// cell death...
         out_grid[cx][cy] = cell_future;
      }
   
   
      final static void trivialCopy() {
         if ((hside == 1) & (vside == 1)) {
            out_grid[0][0] = in_grid[0][0];
         }
         else
         {
            if (vside == 1) {
               for (cx = 0; cx < hside; cx++) {
                  out_grid[cx][0] = in_grid[cx][0];
               }
            }
            else
            {
               if (hside == 1) {
                  for (cy = 0; cy < vside; cy++) {
                     out_grid[0][cy] = in_grid[0][cy];
                  }
               }
               else {
                  for (cx = 0; cx < hside; cx++) {
                     for (cy = 0; cy < vside; cy++) {
                        out_grid[cx][cy] = in_grid[cy][cy];
                     }
                  }
               }
            }
         }
      }
   
   
      final static void simpleCopy() {
         for (cx = 0; cx < hside; cx++) {
            for (cy = 0; cy < vside; cy++) {
               out_grid[cx][cy] = in_grid[cx][cy];
            }
         }
      }
   
   /*
      final static void invertTriumphantEdgesXX(int cx2, int cy2) {
         next_ss = in_grid[cx2][cy2];
      
         in_grid[cx2][cy2] = (next_ss & 0xFF00FFFF) | ((next_ss & 7) << 16);
      }
   
   
      final static void invertTriumphantEdges(int cx2, int cy2) {
         next_ss = in_grid[cx2][cy2];
      
         in_grid[cx2][cy2] = next_ss;
      }
   
   
      final static void processSafelyTriumphant(int cx2, int cy2) {
         if ((cy2 & 1) == 0) {
            temp = (safeRead(cx2 - 1, cy2 - 1) & 4) | 
                  (safeRead(cx2 + 1, cy2    ) & 2) | 
                  (safeRead(cx2 - 1, cy2 + 1) & 1);
         }
         else
         {
            temp = (safeRead(cx2    , cy2 - 1) & 4) | 
                  (safeRead(cx2 + 1, cy2    ) & 2) | 
                  (safeRead(cx2    , cy2 + 1) & 1);
         }
      
         out_grid[cx2][cy2] = in_grid[cx2][cy2]; //  & -0x100) | triumphant_inverse[temp];
      }
   
   
      final static void processInverseSafelyTriumphant(int cx2, int cy2) {
         if ((cy2 & 1) == 0) {
            temp = ((safeRead(cx2    , cy2 + 1) & 0x40000) >>> 16) | 
                  ((safeRead(cx2 - 1, cy2    ) & 0x20000) >>> 16) | 
                  ((safeRead(cx2    ,cy2 - 1) & 0x10000) >>> 16);
         }
         else
         {
            temp = ((safeRead(cx2 + 1, cy2 + 1) & 0x40000) >>> 16) | 
                  ((safeRead(cx2 - 1, cy2    ) & 0x20000) >>> 16) | 
                  ((safeRead(cx2 + 1,cy2 - 1) & 0x10000) >>> 16);
         }
      
         out_grid[cx2][cy2] = in_grid[cx2][cy2]; //  & -0x100) | temp; // triumphant_inverse2[temp];
      }
   */
   
      final static int safeRead(int x, int y) {
         if (x < 0) 
            return 0;
      
         if (x > hsidemo) 
            return 0;
      
         if (y < 0) 
            return 0;
      
         if (y > vsidemo) 
            return 0;
      
         return in_grid[x][y];
      }
   
   
      final static void swap_grids() {
         // swap them...
         tmp_grid = in_grid;
         in_grid = out_grid;
         out_grid = tmp_grid;
      }
   
   
      final static void do_any_mutation() {      
      	 // mutation...
         if (mutation_rate != _MUT_OFF) {
            if ((generation & 3) == 0) {
               rnd_frame = rnd.nextInt();
            
               for (temp = ((mutation_rate * hside * vside) >>> 12); temp-- > 0; ) {
                  cx = (rnd_frame >>> 2) % hside;
                  cy = (rnd_frame >>> 12) % vside;
               
                  rnd_frame = rnd.nextInt(); // *need* new value due to loop...?
               
                  if ((out_grid[cx][cy] != DEAD) && (out_grid[cx][cy] != WALL)) {
                     out_grid[cx][cy] = randomCell();
                  }
               }
            }
         }
      }
   
   
      final static void do_any_radiation() {      
      	 // radiation...
         if ((generation & 3) == 0) {
            if (radiation_rate != _MUT_OFF) {
               rnd_frame = rnd.nextInt();
            
               for (temp = ((radiation_rate * hside * vside) >>> 12); temp-- > 0; ) {
                  cx = (rnd_frame >>> 2) % hside;
                  cy = (rnd_frame >>> 12) % vside;
               
                  rnd_frame = rnd.nextInt(); // *need* new value due to loop...?
               
                  if (out_grid[cx][cy] != WALL) {
                     out_grid[cx][cy] = DEAD;
                  }
               }
            }
         }
      }
   
   
      final public static void completelyClearGid(Graphics g) {
         int width = hside * gridsize;
      
         graphics_handle.setColor(GridColour);
         graphics_handle.fillRect(0,0,width + 1,width + 1);
      }
   
   
      private static void redrawAllSOD() {
         temp_x = cx * gridsize;
         temp_y = cy * hexgridsize;
      
         temp = in_grid[cx][cy];
         if (temp == WALL) {
            temp = 25;
         }
         else
         {
            if ((temp & mask_dev) == DEV_HEAD) {
               temp = (temp & mask_act) + 12; // draw head coloured bit...
               temp2 = 0x00; // between eyes // 03
               temp3 = 0xF7; // behind head
               forward_colour = 0x00; // not used
               backward_colour = snake_eye_colour; // eyes
            }
            else
            {
               temp = temp & mask_act;
               temp2 = 0xF8;
               temp3 = 0xF7;
               forward_colour = 0x15;
               backward_colour = 0x21;
            }
         }
      
         // 1 (NW)
         temp4 = snake_LUT1[temp];
         snakeTranslate();
      
         setUpColour();
      
         poly3_x[0] = temp_x; // left point
         poly3_x[1] = temp_x + halfcellsize; // top pointL
         poly3_x[2] = poly3_x[1]; // top pointL
      
         poly3_y[0] = temp_y + quartcellsize; // left point
         poly3_y[1] = temp_y; // top point
         poly3_y[2] = temp_y + halfcellsize; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance3();
      
         graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
      
         // 2 (NE)
         temp4 = snake_LUT2[temp];
         snakeTranslate();
      
         setUpColour();
      
         poly3_x[0] = temp_x + halfgridsize + halfcellsize; // right point
         poly3_x[1] = temp_x + halfgridsize; // top pointL
         poly3_x[2] = poly3_x[1]; // top pointL
      
         poly3_y[0] = temp_y + quartcellsize; // left point
         poly3_y[1] = temp_y; // top point
         poly3_y[2] = temp_y + halfcellsize; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance3();
      
         graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
      
         // 3 (W)
         temp4 = snake_LUT3[temp];
         snakeTranslate();
      
         setUpColour();
      
         poly3_x[0] = temp_x; // right point
         poly3_x[1] = temp_x + halfcellsize - 1; // top pointL
         poly3_x[2] = temp_x; // top pointL
      
         poly3_y[0] = temp_y + quartgridsize; // left point
         poly3_y[1] = temp_y + halfgridsize - 1; // top point
         poly3_y[2] = temp_y + halfgridsize + quartcellsize - 1; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance3();
      
         graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
      
         // 4 (E)
         temp4 = snake_LUT4[temp];
         snakeTranslate();
      
         setUpColour();
      
         poly3_x[0] = temp_x + cellsize; // right point
         poly3_x[1] = temp_x + halfgridsize + 1; // top pointL
         poly3_x[2] = temp_x + cellsize; // top pointL
      
         poly3_y[0] = temp_y + quartgridsize; // left point
         poly3_y[1] = temp_y + halfgridsize - 1; // top point
         poly3_y[2] = temp_y + halfgridsize + quartcellsize - 1; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance3();
      
         graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
      
         // 5 (SW)
         temp4 = snake_LUT5[temp];
         snakeTranslate();
      
         setUpColour();
      
         poly3_x[0] = temp_x; // left point
         poly3_x[1] = temp_x + halfcellsize; // top pointL
         poly3_x[2] = poly3_x[1]; // top pointL
      
      
         poly3_y[0] = temp_y + halfgridsize + quartcellsize; // top point
         poly3_y[1] = temp_y + halfgridsize; // left point
         poly3_y[2] = temp_y + cellsize - 1; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance3();
      
         graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
      
         // 6 (SE)
         temp4 = snake_LUT6[temp];
         snakeTranslate();
      
         setUpColour();
      
         poly3_x[0] = temp_x + halfgridsize + halfcellsize; // right point
         poly3_x[1] = temp_x + halfgridsize; // top pointL
         poly3_x[2] = poly3_x[1]; // top pointL
      
         poly3_y[0] = temp_y + halfgridsize + quartcellsize; // top point
         poly3_y[1] = temp_y + halfgridsize; // left point
         poly3_y[2] = temp_y + cellsize - 1; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance3();
      
         graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
      }
   
   
      private static void redrawSOD() {
         temp_x = cx * gridsize;
         temp_y = cy * hexgridsize;
      
         temp = in_grid[cx][cy];
         tempA = out_grid[cx][cy];
      
         if (temp != tempA) {
            if (((temp & mask_dev) == DEV_HEAD) || ((tempA & mask_dev) == DEV_HEAD) || ((temp & mask_act) != (tempA & mask_act))) {
               if (temp == WALL) {
                  temp = 25;
               }
               else
               {
                  if ((temp & mask_dev) == DEV_HEAD) {
                     temp = (temp & mask_act) + 12; // draw head coloured bit...
                     temp2 = 0x00; // between eyes // 04
                     temp3 = 0xF7; // behind head
                     forward_colour = 0x00; // not used
                     backward_colour = snake_eye_colour; // eyes
                  }
                  else
                  {
                     temp = temp & mask_act;
                     temp2 = 0xF8;
                     temp3 = 0xF7;
                     forward_colour = 0x15;
                     backward_colour = 0x21;
                  }
               }
            
            // 1 (NW)
               temp4 = snake_LUT1[temp];
               snakeTranslate();
            
               setUpColour();
            
               poly3_x[0] = temp_x; // left point
               poly3_x[1] = temp_x + halfcellsize; // top pointL
               poly3_x[2] = poly3_x[1]; // top pointL
            
               poly3_y[0] = temp_y + quartcellsize; // left point
               poly3_y[1] = temp_y; // top point
               poly3_y[2] = temp_y + halfcellsize; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance3();
            
               graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
            
            // 2 (NE)
               temp4 = snake_LUT2[temp];
               snakeTranslate();
            
               setUpColour();
            
               poly3_x[0] = temp_x + halfgridsize + halfcellsize; // right point
               poly3_x[1] = temp_x + halfgridsize; // top pointL
               poly3_x[2] = poly3_x[1]; // top pointL
            
               poly3_y[0] = temp_y + quartcellsize; // left point
               poly3_y[1] = temp_y; // top point
               poly3_y[2] = temp_y + halfcellsize; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance3();
            
               graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
            
            // 3 (W)
               temp4 = snake_LUT3[temp];
               snakeTranslate();
            
               setUpColour();
            
               poly3_x[0] = temp_x; // right point
               poly3_x[1] = temp_x + halfcellsize - 1; // top pointL
               poly3_x[2] = temp_x; // top pointL
            
               poly3_y[0] = temp_y + quartgridsize; // left point
               poly3_y[1] = temp_y + halfgridsize - 1; // top point
               poly3_y[2] = temp_y + halfgridsize + quartcellsize - 1; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance3();
            
               graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
            
            // 4 (E)
               temp4 = snake_LUT4[temp];
               snakeTranslate();
            
               setUpColour();
            
               poly3_x[0] = temp_x + cellsize; // right point
               poly3_x[1] = temp_x + halfgridsize + 1; // top pointL
               poly3_x[2] = temp_x + cellsize; // top pointL
            
               poly3_y[0] = temp_y + quartgridsize; // left point
               poly3_y[1] = temp_y + halfgridsize - 1; // top point
               poly3_y[2] = temp_y + halfgridsize + quartcellsize - 1; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance3();
            
               graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
            
            // 5 (SW)
               temp4 = snake_LUT5[temp];
               snakeTranslate();
            
               setUpColour();
            
               poly3_x[0] = temp_x; // left point
               poly3_x[1] = temp_x + halfcellsize; // top pointL
               poly3_x[2] = poly3_x[1]; // top pointL
            
            
               poly3_y[0] = temp_y + halfgridsize + quartcellsize; // top point
               poly3_y[1] = temp_y + halfgridsize; // left point
               poly3_y[2] = temp_y + cellsize - 1; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance3();
            
               graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
            
            // 6 (SE)
               temp4 = snake_LUT6[temp];
               snakeTranslate();
            
               setUpColour();
            
               poly3_x[0] = temp_x + halfgridsize + halfcellsize; // right point
               poly3_x[1] = temp_x + halfgridsize; // top pointL
               poly3_x[2] = poly3_x[1]; // top pointL
            
               poly3_y[0] = temp_y + halfgridsize + quartcellsize; // top point
               poly3_y[1] = temp_y + halfgridsize; // left point
               poly3_y[2] = temp_y + cellsize - 1; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance3();
            
               graphics_handle.fillPolygon(poly3_x, poly3_y, 3);
            }
         }
      }
   
      private static void snakeTranslate() {
         switch (temp4) {
            case 0:
               colour = 0; // background
            
               break;
         
            case 1:
               colour = snake_bg_colour;
            
               break;
         
            case 2:
               colour = forward_colour; // front
            
               break;
         
            case 3:
               colour = backward_colour; // back
            
               break;
         
            case 4:
               colour = temp2;  // forwards eye
            
               break;
         
            case 5:
               colour = temp3; // tail
            
               break;
         
            case 6:
               colour = snake_eye_colour; // eyes!
            
               break;
         
            case 7:
               colour = wall_colour; // eyes!
            
               break;
         }
      }
   
   
      private static void redrawThree() {
         temp = in_grid[cx][cy];
         tempA = out_grid[cx][cy];
      
         if (temp != tempA) {
         
            temp_x = cx * gridsize;
            temp_y = cy * hexgridsize;
         
            if ((temp & mask_dev) == DEV_HEAD) {
               default_colour = snake_eye_colour;
               temp2 = 4;
               temp = (temp & mask_act); // temp  = 99; // draw all cells head coloured.
            }
            else
            {
               default_colour = 128;
               temp2 = temp & mask_dev;
               temp = (temp & mask_act);
            }
         
            if ((tempA & mask_dev) == DEV_HEAD) {
               default_colourA = snake_eye_colour;
               temp2A = 4;
               tempA = (tempA & mask_act); // temp  = 99; // draw all cells head coloured.
            }
            else
            {
               default_colourA = 128;
               temp2A = tempA & mask_dev;
               tempA = (tempA & mask_act);
            }
         
            if ((temp == 1) || (temp == 2) || (temp == 4) || (temp == 5) || (temp == 7) || (temp == 8)|| (temp == 10) || (temp == 11)) {
               colour = default_colour;
            }
            else
            {
               colour = temp2;
            }
         
            if ((tempA == 1) || (tempA == 2) || (tempA == 4) || (tempA == 5) || (tempA == 7) || (tempA == 8)|| (tempA == 10) || (tempA == 11)) {
               colourA = default_colourA;
            }
            else
            {
               colourA = temp2A;
            }
         
            if (colour != colourA) {
               setUpColour();
            
               poly6_x[0] = temp_x + quartgridsize + 1; // left point
               poly6_x[1] = temp_x + halfcellsize; // top pointL
               poly6_x[2] = temp_x + halfgridsize; // top pointR
               poly6_x[3] = temp_x + cellsize; // right point
               poly6_x[4] = poly6_x[3]; // bottom pointR
               poly6_x[5] = temp_x + halfgridsize; // bottom pointL
            
               poly6_y[0] = temp_y + (quartcellsize >>> 1); // left point
               poly6_y[1] = temp_y; // top point
               poly6_y[2] = temp_y; // top point
               poly6_y[3] = temp_y + quartcellsize; // poly6_y[0]; // right point
               poly6_y[4] = temp_y + halfcellsize; // bottom point
               poly6_y[5] = temp_y + halfcellsize; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance6();
            
               graphics_handle.fillPolygon(poly6_x, poly6_y, 6);
            }
         
         // left hand one...
            if ((temp == 1) || (temp == 3) || (temp == 4) || (temp == 6) || (temp == 7) || (temp == 9) || (temp == 10) || (temp == 12)) {
               colour = default_colour;
            }
            else
            {
               colour = temp2;
            }
         
            if ((tempA == 1) || (tempA == 3) || (tempA == 4) || (tempA == 6) || (tempA == 7) || (tempA == 9)|| (tempA == 10) || (tempA == 12)) {
               colourA = default_colourA;
            }
            else
            {
               colourA = temp2A;
            }
         
            if (colour != colourA) {
               setUpColour();
            
               poly8_x[0] = temp_x;
               poly8_x[1] = temp_x + quartgridsize - 1;
               poly8_x[2] = temp_x + quartgridsize;
               poly8_x[3] = temp_x + halfcellsize;
               poly8_x[4] = poly8_x[3];
               poly8_x[5] = poly8_x[2];
               poly8_x[6] = poly8_x[1];
               poly8_x[7] = poly8_x[0];
            
               poly8_y[0] = temp_y + quartgridsize;
               poly8_y[1] = temp_y + (quartcellsize >>> 1) + 1;
               poly8_y[2] = temp_y + (quartcellsize >>> 1);
               poly8_y[3] = temp_y + halfcellsize;
               poly8_y[4] = temp_y + halfgridsize;
               poly8_y[5] = temp_y + halfgridsize + quartcellsize + (quartgridsize >>> 1);
               poly8_y[6] = temp_y + halfgridsize + quartcellsize + (quartgridsize >>> 1) - 1;
               poly8_y[7] = temp_y + halfgridsize + quartcellsize;
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance8();
            
               graphics_handle.fillPolygon(poly8_x, poly8_y, 8);
            }
         // bottom right one...
            if ((temp == 2) || (temp == 3) || (temp == 5) || (temp == 6) || (temp == 8) || (temp == 9) || (temp == 11) || (temp == 12)) {
               colour = default_colour;
            }
            else
            {
               colour = temp2;
            }
         
            if ((tempA == 2) || (tempA == 3) || (tempA == 5) || (tempA == 6) || (tempA == 8) || (tempA == 9)|| (tempA == 11) || (tempA == 12)) {
               colourA = default_colourA;
            }
            else
            {
               colourA = temp2A;
            }
         
            if (colour != colourA) {
               setUpColour();
            
               poly6_x[0] = temp_x + quartgridsize + 1; // left point
               poly6_x[1] = temp_x + halfgridsize; // top pointL
               poly6_x[2] = temp_x + halfgridsize; // top pointR
               poly6_x[3] = temp_x + cellsize; // right point
               poly6_x[4] = poly6_x[3];        // bottom pointR
               poly6_x[5] = temp_x + halfgridsize; // bottom pointL
            
               poly6_y[0] = temp_y + halfgridsize + quartgridsize + ((quartcellsize - 1) >>> 1); // left point
               poly6_y[1] = temp_y + cellsize; // top point
               poly6_y[2] = temp_y + cellsize; // top point
               poly6_y[3] = temp_y + cellsize - quartgridsize; // poly6_y[0]; // right point
               poly6_y[4] = temp_y + halfgridsize; // bottom point
               poly6_y[5] = temp_y + halfgridsize; // bottom point
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance6();
            
               graphics_handle.fillPolygon(poly6_x, poly6_y, 6);
            }
         }
      }
   
   
      private static void redrawAllThree() {
         temp = in_grid[cx][cy];
         temp_x = cx * gridsize;
         temp_y = cy * hexgridsize;
      
         temp = in_grid[cx][cy];
         if ((temp & mask_dev) == DEV_HEAD) {
            default_colour = snake_eye_colour;
            temp2 = 4;
            temp = (temp & mask_act); // temp  = 99; // draw all cells head coloured.
         }
         else
         {
            default_colour = 128;
            temp2 = temp & mask_dev;
            temp = (temp & mask_act);
         }
      
         if ((temp == 1) || (temp == 2) || (temp == 4) || (temp == 5) || (temp == 7) || (temp == 8)|| (temp == 10) || (temp == 11)) {
            colour = default_colour;
         }
         else
         {
            colour = temp2;
         }
      
         setUpColour();
      
         poly6_x[0] = temp_x + quartgridsize + 1; // left point
         poly6_x[1] = temp_x + halfcellsize; // top pointL
         poly6_x[2] = temp_x + halfgridsize; // top pointR
         poly6_x[3] = temp_x + cellsize; // right point
         poly6_x[4] = poly6_x[3]; // bottom pointR
         poly6_x[5] = temp_x + halfgridsize; // bottom pointL
      
         poly6_y[0] = temp_y + (quartcellsize >>> 1); // left point
         poly6_y[1] = temp_y; // top point
         poly6_y[2] = temp_y; // top point
         poly6_y[3] = temp_y + quartcellsize; // poly6_y[0]; // right point
         poly6_y[4] = temp_y + halfcellsize; // bottom point
         poly6_y[5] = temp_y + halfcellsize; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance6();
      
         graphics_handle.fillPolygon(poly6_x, poly6_y, 6);
      
         // left hand one...
         if ((temp == 1) || (temp == 3) || (temp == 4) || (temp == 6) || (temp == 7) || (temp == 9) || (temp == 10) || (temp == 12)) {
            colour = default_colour;
         }
         else
         {
            colour = temp2;
         }
      
         setUpColour();
      
         poly8_x[0] = temp_x;
         poly8_x[1] = temp_x + quartgridsize - 1;
         poly8_x[2] = temp_x + quartgridsize;
         poly8_x[3] = temp_x + halfcellsize;
         poly8_x[4] = poly8_x[3];
         poly8_x[5] = poly8_x[2];
         poly8_x[6] = poly8_x[1];
         poly8_x[7] = poly8_x[0];
      
         poly8_y[0] = temp_y + quartgridsize;
         poly8_y[1] = temp_y + (quartcellsize >>> 1) + 1;
         poly8_y[2] = temp_y + (quartcellsize >>> 1);
         poly8_y[3] = temp_y + halfcellsize;
         poly8_y[4] = temp_y + halfgridsize;
         poly8_y[5] = temp_y + halfgridsize + quartcellsize + (quartgridsize >>> 1);
         poly8_y[6] = temp_y + halfgridsize + quartcellsize + (quartgridsize >>> 1) - 1;
         poly8_y[7] = temp_y + halfgridsize + quartcellsize;
      
         if ((cy & 1) != 0) 
            adjustXHexDistance8();
      
         graphics_handle.fillPolygon(poly8_x, poly8_y, 8);
      
         // bottom right one...
         if ((temp == 2) || (temp == 3) || (temp == 5) || (temp == 6) || (temp == 8) || (temp == 9) || (temp == 11) || (temp == 12)) {
            colour = default_colour;
         }
         else
         {
            colour = temp2;
         }
      
         setUpColour();
      
      
         poly6_x[0] = temp_x + quartgridsize + 1; // left point
         poly6_x[1] = temp_x + halfgridsize; // top pointL
         poly6_x[2] = temp_x + halfgridsize; // top pointR
         poly6_x[3] = temp_x + cellsize; // right point
         poly6_x[4] = poly6_x[3];        // bottom pointR
         poly6_x[5] = temp_x + halfgridsize; // bottom pointL
      
         poly6_y[0] = temp_y + halfgridsize + quartgridsize + ((quartcellsize - 1) >>> 1); // left point
         poly6_y[1] = temp_y + cellsize; // top point
         poly6_y[2] = temp_y + cellsize; // top point
         poly6_y[3] = temp_y + cellsize - quartgridsize; // poly6_y[0]; // right point
         poly6_y[4] = temp_y + halfgridsize; // bottom point
         poly6_y[5] = temp_y + halfgridsize; // bottom point
      
         if ((cy & 1) != 0) 
            adjustXHexDistance6();
      
         graphics_handle.fillPolygon(poly6_x, poly6_y, 6);
      
      }
   
   
      private static void adjustXHexDistance3() {
         for (last_temp = 3; last_temp-- > 0; ) {
            poly3_x[last_temp] += halfgridsize;
         }
      }
   
   
      private static void adjustXHexDistance4() {
         for (last_temp = 4; last_temp-- > 0; ) {
            poly4_x[last_temp] += halfgridsize;
         }
      }
   
   
      private static void adjustXHexDistance6() {
         for (last_temp = 6; last_temp-- > 0; ) {
            poly6_x[last_temp] += halfgridsize;
         }
      }
   
   
      private static void adjustXHexDistance8() {
         for (last_temp = 8; last_temp-- > 0; ) {
            poly8_x[last_temp] += halfgridsize;
         }
      }
   
   
      private static void redrawAllCellTypes() {
         temp = in_grid[cx][cy];
         temp2 = out_grid[cx][cy];
      
         temp_x = cx * gridsize;
         temp_y = cy * hexgridsize;
      
         if ((temp & mask_dev) == DEV_HEAD) {
            colour = snake_eye_colour;
         }
         else
         {
            temp = (temp & mask_dev);
            colour = (temp >>>  3) ^ (temp >>> 4);
         }
      
         setUpColour();
      
         poly8_x[0] = temp_x; // left point
         poly8_x[1] = temp_x + halfcellsize; // top pointL
         poly8_x[2] = poly8_x[1] + 1; // top pointR
         poly8_x[3] = temp_x + halfgridsize + halfcellsize; // right point
         poly8_x[4] = poly8_x[3]; // right point
         poly8_x[5] = poly8_x[2]; // bottom pointR
         poly8_x[6] = poly8_x[1]; // bottom pointL
         poly8_x[7] = poly8_x[0];
      
         poly8_y[0] = temp_y + quartcellsize; // left point
         poly8_y[1] = temp_y; // top point
         poly8_y[2] = temp_y; // top point
         poly8_y[3] = poly8_y[0]; // right point
         poly8_y[4] = temp_y + halfgridsize + quartcellsize;
         poly8_y[5] = temp_y + cellsize - 1;
         poly8_y[6] = poly8_y[5];
         poly8_y[7] = poly8_y[4];
      
         if ((cy & 1) != 0) 
            adjustXHexDistance8();
      
         graphics_handle.fillPolygon(poly8_x, poly8_y, 8);
      }
   
   
      private static void redrawCellTypes() {
         temp = in_grid[cx][cy];
         temp2 = out_grid[cx][cy];
      
         if (temp != temp2) {
            temp = in_grid[cx][cy];
            if ((temp & mask_dev) == DEV_HEAD) {
               colour = snake_eye_colour;
            }
            else
            {
               temp = (temp & mask_dev);
               colour = (temp >>>  3) ^ (temp >>> 4);
            }
         
            temp_x = cx * gridsize;
            temp_y = cy * hexgridsize;
         
            setUpColour();
         
            poly8_x[0] = temp_x; // left point
            poly8_x[1] = temp_x + halfcellsize; // top pointL
            poly8_x[2] = poly8_x[1] + 1; // top pointR
            poly8_x[3] = temp_x + halfgridsize + halfcellsize; // right point
            poly8_x[4] = poly8_x[3]; // right point
            poly8_x[5] = poly8_x[2]; // bottom pointR
            poly8_x[6] = poly8_x[1]; // bottom pointL
            poly8_x[7] = poly8_x[0];
         
            poly8_y[0] = temp_y + quartcellsize; // left point
            poly8_y[1] = temp_y; // top point
            poly8_y[2] = temp_y; // top point
            poly8_y[3] = poly8_y[0]; // right point
            poly8_y[4] = temp_y + halfgridsize + quartcellsize;
            poly8_y[5] = temp_y + cellsize - 1;
            poly8_y[6] = poly8_y[5];
            poly8_y[7] = poly8_y[4];
         
            if ((cy & 1) != 0) 
               adjustXHexDistance8();
         
            graphics_handle.fillPolygon(poly8_x, poly8_y, 8);
         }      
      }
   
   
      private static void redrawAllTypes() {
         temp_x = cx * gridsize;
         temp_y = cy * hexgridsize;
      
         temp = in_grid[cx][cy];
         if ((temp & mask_dev) == DEV_HEAD) {
            colour = snake_eye_colour;
         }
         else
         {
            temp = temp & mask_act;
            colour = (temp << 1) ^ (temp);
         }
      
         setUpColour();
      
         poly8_x[0] = temp_x; // left point
         poly8_x[1] = temp_x + halfcellsize; // top pointL
         poly8_x[2] = poly8_x[1] + 1; // top pointR
         poly8_x[3] = temp_x + halfgridsize + halfcellsize; // right point
         poly8_x[4] = poly8_x[3]; // right point
         poly8_x[5] = poly8_x[2]; // bottom pointR
         poly8_x[6] = poly8_x[1]; // bottom pointL
         poly8_x[7] = poly8_x[0];
      
         poly8_y[0] = temp_y + quartcellsize; // left point
         poly8_y[1] = temp_y; // top point
         poly8_y[2] = temp_y; // top point
         poly8_y[3] = poly8_y[0]; // right point
         poly8_y[4] = temp_y + halfgridsize + quartcellsize;
         poly8_y[5] = temp_y + cellsize - 1;
         poly8_y[6] = poly8_y[5];
         poly8_y[7] = poly8_y[4];
      
         if ((cy & 1) != 0) 
            adjustXHexDistance8();
      
         graphics_handle.fillPolygon(poly8_x, poly8_y, 8);
      }
   
   
   
      private static void redrawTypes() {
         temp = in_grid[cx][cy];
         temp2 = out_grid[cx][cy];
      
         if (temp != temp2) {
            if ((temp & mask_dev) == DEV_HEAD) {
               colour = snake_eye_colour;
            }
            else
            {
               temp = temp & mask_act;
               colour = (temp << 1) ^ (temp);
            }
         
            if ((temp2 & mask_dev) == DEV_HEAD) {
               colourA = snake_eye_colour;
            }
            else
            {
               temp2 = temp2 & mask_act;
               colourA = (temp2 << 1) ^ (temp2);
            }
         
            if (colour != colourA) {
               temp_x = cx * gridsize;
               temp_y = cy * hexgridsize;
            
               setUpColour();
            
               poly8_x[0] = temp_x; // left point
               poly8_x[1] = temp_x + halfcellsize; // top pointL
               poly8_x[2] = poly8_x[1] + 1; // top pointR
               poly8_x[3] = temp_x + halfgridsize + halfcellsize; // right point
               poly8_x[4] = poly8_x[3]; // right point
               poly8_x[5] = poly8_x[2]; // bottom pointR
               poly8_x[6] = poly8_x[1]; // bottom pointL
               poly8_x[7] = poly8_x[0];
            
               poly8_y[0] = temp_y + quartcellsize; // left point
               poly8_y[1] = temp_y; // top point
               poly8_y[2] = temp_y; // top point
               poly8_y[3] = poly8_y[0]; // right point
               poly8_y[4] = temp_y + halfgridsize + quartcellsize;
               poly8_y[5] = temp_y + cellsize - 1;
               poly8_y[6] = poly8_y[5];
               poly8_y[7] = poly8_y[4];
            
               if ((cy & 1) != 0) 
                  adjustXHexDistance8();
            
               graphics_handle.fillPolygon(poly8_x, poly8_y, 8);
            }      
         }
      }
   
   
      private static void setUpColour() {
      
         if (colour!= last_colour) {
            graphics_handle.setColor(colours[colour]);
            last_colour = colour;
         }
      }
   
   
      final public static void redraw_changed(Graphics g) {
         graphics_handle = g;
      
         last_colour = -1;
      
         if (RepaintAll || (HexHAL.frame_frequency > 16)) { //  && (HexHAL.busy == 0)) {
            graphics_handle.setColor(Color.black);
            graphics_handle.fillRect(0,0,9999,9999);
            switch (display_type) {
               case HEADSANDCELLS:
               
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawAllCellTypes(); // redrawAllThree();
                     }
                  }
               
                  break;
            
               case CELLTYPES:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawAllTypes();
                     }
                  }
               
                  break;
            
               case DEVELOPMENT:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawAllThree();
                     }
                  }
               
                  break;
            
               case SNAKELIKE:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawAllSOD();
                     }
                  }
               
                  break;
            }
         
            RepaintAll = false;
         }
         else
         {
            switch (display_type) {
               case HEADSANDCELLS:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawCellTypes(); // redrawAllThree();
                     }
                  }
               
                  break;
            
               case CELLTYPES:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawTypes();
                     }
                  }
               
                  break;
            
               case DEVELOPMENT:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawThree();
                     }
                  }
               
                  break;
            
               case SNAKELIKE:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawSOD();
                     }
                  }
               
                  break;
            }
         }
      }
   
   
      final public static int getCoveragePercentage() {
         //if ((sparse) != 0) {
         //temp = coverage_counter; // last_living;
         /*
         } 
         else
         {
            temp = 0;
         
            for (cx = hside; cx-- > 0; ) {
               for (cy = vside; cy-- > 0; ) {
                  if ((in_grid[cx][cy].a0 & mask_a0_sta) > EDGE)
                     temp++;
               }
            }
         }
      */
      
         temp = coverage_counter * 101 / (hside * vside);
         if (temp > 99)
            temp = 100;
      
         return temp;
      }
   
   
      final public static void invertAll() {
         // for (cx = 0; cx < number_HexHAL_LUT; cx++) {
         //    LUT[cx].invert();
         // }
      }
   
      final public static int isHexagonal() {
         if ((geometry == SOD) || (geometry == QBERT) || (geometry == TRIUMPHANT)) {
            return 1;
         }
      
         return 0;
      }	
   
      public static int getMaskValue() {
         mask_value = (1 << getBPCValue()) - 1;
      
         return mask_value;
      }
   
   
      public static int getBPCValue() {
         switch (HexHAL_Grid.geometry) {
            case HexHAL_Grid.WOLF:
               BPC_value = 1;
            
               break;
         
            case HexHAL_Grid.QBERT:
            case HexHAL_Grid.TRIUMPHANT:
               BPC_value = 3;
            
               break;
         
            case HexHAL_Grid.MARGOLUS:
               BPC_value = 4;
            
               break;
            case HexHAL_Grid.SOD:
               BPC_value = 6;
            
               break;
         }
      
         return BPC_value;
      }
   
      public static int randomCell() {
         do {
            do {
               temp = rnd.nextInt() & (mask_act | mask_dev);
            } while ((temp & mask_act) >= 0x0C);
         } while ((temp & mask_dev) >= 0x60);
      
         return temp + 0x11;
      }
   
   }

